



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Docker入门 第一课 --.Net Core 使用Docker全程记录</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Docker入门 第一课 --.Net Core 使用Docker全程记录</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 08:33:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>微服务架构无疑是当前最火热的开发架构，而Docker作为微服务架构的首选工具，是我们必须要了解掌握的。</p>
<p>我通过一天的时间，网上查文档，了解基础概念，安装Docker，试验Docker命令，通过Docker，成功部署运行Asp.NET core示例程序，算是基本入门。</p>
<p>这篇文章是自己总结的Docker入门篇，力求简洁，快速入门，以最短的时间看到学习成果，为深入学习Docker做基础。</p>
<h2><strong>学习前提：不要畏惧</strong></h2>
<p>面对未知，人们心里往往会产生恐惧，这是人与生俱来的，所以，我们在进入新的领域之前，首先要克服的是自己的畏难心理。不要因为困难，看几眼就放弃，那样你永远学不会。</p>
<p>面对新的未知领域，我们要把它当成一座灯塔，让它指引我们前进的方向。</p>
<h2>第一：了解几个概念</h2>
<p><strong>镜像（Image）</strong>：相信大家看到这个词，都明白什么意思，我们可以把它理解为操作系统的安装盘，Ghost镜像。我给它个定义，就叫：Docker基础运行环境副本。</p>
<p><strong>容器（Container）</strong>：运行中的Docker实例，称为容器。也就是一个镜像（Image）的运行时状态。</p>
<p><strong>镜像仓库（Repository）</strong>：Docker为开发者提供了面向各种环境的已经打包好的镜像，这些镜像构成了一个镜像仓库。开发者只需找到自己需要的Docker镜像，下载到本地，添加自己的应用上去，运行即可，某些工具类的镜像，可无需修改，直接运行。</p>
<p><strong>Docker 主机（Host）</strong>：运行着Docker容器的计算机或虚拟机，用于执行Docker的守护进程。</p>
<p><strong>Docker客户端（Client）：</strong>是与Docker主机守护进程进行通信的工具，如：Docker控制台。</p>
<h2>第二：安装Docker</h2>
<p>不同操作系统按照方式不同，以Win7系统为例，需要利用 docker toolbox 来安装，可以使用阿里云的镜像来下载。</p>
<p>下载地址：<a href="http://mirrors.aliyun.com/docker-toolbox/windows/docker-toolbox/" rel="external nofollow noreferrer">http://mirrors.aliyun.com/docker-toolbox/windows/docker-toolbox/</a></p>
<p>安装完成之后，在桌面找到三个启动图标：Oracle VM VirtualBox，Kitematic(Alpha)，Docker Quickstart &hellip;。</p>
<p>安装完成之后，建议重启一下计算机。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/211353/201806/211353-20180621205705525-146340737.png" /></p>
<p><strong>Oracle VM VirtualBox ：</strong>是一个虚拟机程序。Docker是运行在Linux环境下的，要想在Windows下运行，必须借助虚拟机。感兴趣的话可以留着以后研究。</p>
<p><strong>kitematic（alpha）：</strong>是docker推出的GUI工具，可以更简便地操作Docker，非常适合windows用户使用习惯，<strong>推荐大家试试</strong>。这个alpha表示预览版吧，可能功能还不完善。</p>
<p><strong>Docker Quickstart Terminal：</strong>是Docker控制台启动程序，双击图标启动Docker。</p>
<p>如果一切正常的话，可以看到以下界面。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/211353/201806/211353-20180621205722203-1232676826.png" /></p>
<p>如果启动过程中出现下面错误，Looks like something went wrong in step 'Looking for vboxmanage.exe'&hellip;</p>
<p>意思是没有找到虚拟机启动程序，需要设置VirtualBox的环境变量，系统环境变量中增加<strong>VBOX_MSI_INSTALL_PATH</strong>和<strong>VBOX_INSTALL_PATH</strong> 值都为C:\Program Files\Oracle\VirtualBox\ ，即VirtualBox的安装路径，注意后面的\&nbsp;不能少。环境变量设置完成之后，可尝试重新启动。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/211353/201806/211353-20180621205748700-685921761.png" /></p>
<h2>第三：熟悉几个命令</h2>
<p>我建议实际工作中使用图形界面&nbsp;<strong>kitematic</strong>，真的既简单又实用，但Docker命令还是要学习的，最重要的是，使用命令行操作显得更酷更专业。</p>
<p>docker 命令都是以docker开头，下面介绍几个简单，常用的命令。仅作基础介绍，具体参数用法可后期详细学习 。</p>
<p>docker pull：从镜像仓库中拉取镜像 。</p>
<p>docker run：通过镜像创建一个新的容器，并运行。需要注意的是，如果本地没有指定的镜像，会直接去镜像库下载，一定要保证拼写正确。</p>
<p>docker stop：停止一个容器 。</p>
<p>docker start：启动一个容器 。</p>
<p>docker restart：重启一个容器 。</p>
<p>docker ps：列出当前运行的容器机器状态 。</p>
<p>docker images 或 docker image ls：列出本地镜像。</p>
<p>docker build：使用Dockerfile创建自己的镜像。</p>
<h2>第四：操作演示，从hello world开始</h2>
<p>你可以登录Docker官方镜像仓库，选择自己感兴趣的镜像进行试验，这里我们选择最简单的 hello-world。</p>
<p>Docker官方镜像仓库地址：<a href="https://hub.docker.com/" rel="external nofollow noreferrer">https://hub.docker.com</a></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/211353/201806/211353-20180622113555203-150457043.png" /></p>
<p>拉取（下载）镜像，在docker控制台界面，输入命令：<strong>docker pull hello-world</strong></p>
<p>镜像很小，下载很快完成，然后查看一下本地镜像，输入命令：<strong>docker images</strong></p>
<p>不出问题的话，应该可以看到hello-world的镜像文件，运行镜像，输入命令：<strong>docker run hello-world</strong></p>
<p>然后可以看到，控制台返回信息提示，Docker已经正常运行。</p>
<h2>第五：创建自己的Docker镜像</h2>
<p>创建镜像需要使用Dockerfile文件，下面以asp.net core 为例，创建一个自己的镜像，示例中已经创建好了Dockerfile文件，直接使用即可，具体内容留着以后研究。</p>
<p>操作参考：为 .NET Core 应用程序生成 Docker 映像：<a href="https://docs.microsoft.com/zh-cn/dotnet/core/docker/building-net-docker-images" rel="external nofollow noreferrer">https://docs.microsoft.com/zh-cn/dotnet/core/docker/building-net-docker-images</a></p>
<p><strong>首先：确保已经安装了Dotnet Core 2.0</strong></p>
<p><strong>然后：下载asp.net core 示例代码</strong> ：git clone <a href="https://github.com/dotnet/dotnet-docker-samples/" rel="external nofollow noreferrer">https://github.com/dotnet/dotnet-docker-samples/</a></p>
<p><strong>进入项目代码目录，运行示例，测试一下</strong>：</p>
<p><strong>cd aspnetapp</strong></p>
<p><strong>dotnet run</strong></p>
<p>应用程序启动后，在 Web 浏览器中访问&nbsp;<a href="http://localhost:5000/" rel="external nofollow noreferrer">http://localhost:5000</a>。好了，一切正常，没问题。</p>
<p><strong>创建镜像，输入Docker命令：</strong></p>
<p><strong>docker build -t aspnetapp .</strong></p>
<p>生成镜像的过程需要下载依赖镜像包，大概需要十多分钟，执行过程中不要关闭控制台。</p>
<p>镜像生成完成之后，运行一下试试：</p>
<p><strong>docker run -it -p 5002:80 --name aspnetcore aspnetapp</strong></p>
<p>启动完成，打开浏览器：<a href="http://192.168.99.100:5001/" rel="external nofollow noreferrer">http://192.168.99.100:5002/</a></p>
<p>说明：-p 5002:80 表示将Docker主机的5002端口和Docker容器的80端口进行关联映射，即，外部访问使用5002端口，容器内部使用80端口，即 HTTP服务端口。</p>
<p>注意：这里是IP地址，至于这个IP是怎么来的，说实话，我也不知道，我尝试了几次，始终不能访问，然后打开<strong>kitematic</strong>，才发现只有这个IP才能访问。[哭脸]</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/211353/201806/211353-20180621205829643-1236726747.png" /></p>
<h2><strong>&nbsp;后记：</strong></h2>
<p>当看到程序正常启动运行时，是不是满满的成就感，学习就这么简单，最重要的是下定决心迈出行动的第一步。</p>
<p>本篇文章力求简洁，力图尽快看到学习成果，算是给大家深入学习提供的一块敲门砖，垫脚石。</p>
<p>另外文中的概念都是我自己理解的，可能跟标准答案不符，仅供理解和参考。</p>
<p><strong>推荐几个深入学习的网址：</strong></p>
<p>Docker官方镜像仓库：<a href="https://hub.docker.com/" rel="external nofollow noreferrer">https://hub.docker.com</a></p>
<p>Docker菜鸟教程：http://www.runoob.com/docker/docker-tutorial.html</p>
<p>Docker入门教程：http://www.ruanyifeng.com/blog/2018/02/docker-tutorial.html</p>
<p>为 .NET Core 应用程序生成 Docker 映像：<a href="https://docs.microsoft.com/zh-cn/dotnet/core/docker/building-net-docker-images" rel="external nofollow noreferrer">https://docs.microsoft.com/zh-cn/dotnet/core/docker/building-net-docker-images</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r40d78.html">商品库存&OpenCurlyDoubleQuote;存取设计&rdquo;，MySQL事务、表锁、行锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jey008.html">Weblogic部署项目过程中的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0y6e9.html">JS在window和document的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkkv19.html">Ubuntu实现wifi热点</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvj62yq.html">Flex小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyk4zx9.html">eclipse安装activiti工作流插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdrwjm8.html">ASP&period;NET DropDownList1&lowbar;SelectedIndexChanged使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1wknx9.html">&lbrack;又是BUG&rsqb;常见的RuntimeException</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv126zjq.html">构建一个真实的应用电子商务SportsStore&lpar;十&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4e408.html">在js中如何得到上传文件的大小。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrm3z8.html">phpcms插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkyvkd8.html">友盟崩溃日志分析工具 - dSYMTools</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oe3618.html">【转】Vue组件一-父组件传值给子组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2deyo9.html">WCF上传下载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5y3zdq.html">redis整合Spring集群搭建及业务中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25zd5lq.html">k8s2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25oy53q.html">MQ中间件死信队列深度不断增加问题解决案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/96065my9.html">&lbrack;error&rsqb; 1507&num;0&colon; &ast;22 FastCGI sent in stderr&colon; &amp;quot&semi;Primary script unknown&amp;quot&semi; while reading response header from upstream&comma; client&colon; 10&period;0&period;0&period;1&comma; server&colon; www&period;wordpress&period;com&comma; request&colon; &amp;quot&semi;GET &sol;info&period;p</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyye7jmq.html">MVC与单元测试实践之健身网站&lpar;三&rpar;-角色与权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4kv55q.html">函数和常用模块【day06】：json模块（十一）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e4m5em9.html">springboot 学习之路 3（ 集成mybatis ）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wpno0q.html">java实现小学生四则运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2e0nz9.html">Android&sol;IOS手机使用Fiddler抓包</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25k2e3q.html">&commat;Autowired注解与&commat;resource注解的区别&lpar;十分详细&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2yoz9.html">sql视图显示数据不对应</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2ek7z9.html">c&num; 设置MdiClient窗体的背景图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zykey19.html">php curl参数详解之post方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2zle9.html">网站出现403 Forbidden</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2e7mz9.html">org&period;springframework&period;dao&period;InvalidDataAccessResourceUsageException&colon; Unexpected cursor position change&period; Spring Batch 错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2jzz0q.html">【Git】Git pull 强制覆盖本地文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
